#include <cassert>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <pthread.h>

using namespace std;

// y = y + alpha * x
void axpy(int n, double alpha, const double* x, int incX,
      double* y, int incY) {
#pragma omp parallel for
   for (int i = 0; i < n; ++i) {
      y[i*incY] += alpha * x[i*incX];
   }
}

char* cmdname;
void usage() {
   cerr << "Usage: " << cmdname << " [len]" << endl;
   exit(1);
}

void fill_vector(double* a, int len) {
   static double val = 0;
   while (len > 0) {
      *a++ = val; val = val + 1;
      --len;
   }
}

int main(int argc, char** argv) {
   const double a = 0;
   const double b = 1;
   int N = 10000;

   cmdname = *argv++; --argc;
   if (argc > 0) {
      istringstream arg(*argv++); --argc;
      if (!(arg >> N) || N <= 0) usage();
   }
   if (argc > 0) usage();

   double* x = new double[N]; fill_vector(x, N);
   double* y = new double[N]; fill_vector(y, N);
   double alpha = 2;
   axpy(N, alpha, x, 1, y, 1);

#ifdef OUTPUT
   for (int i = 0; i < N; ++i) {
      if (i % 8 == 0) {
	 cout << endl;
      } else {
	 cout << " ";
      }
      cout << y[i];
   }
   cout << endl;
#endif
}
